from query import *
import eep

def bigTest(): 
   print squery(eep.parse('?x <#y> ?z .')[0], 
                eep.parse('<#a> <#y> <#b> .\n<#p> <#y> <#q> .'))
   print rquery(eep.parse('?x <#y> ?z .')[0], 
                eep.parse('<#a> <#y> <#b> .\n<#p> <#y> <#q> .'))
   print rquery(eep.parse('<#Sean> <#likes> ?x .')[0], 
                eep.parse("""<#Sean> <#likes> <#TheSimpsons> .
                             <#Sean> <#likes> <#SemanticWeb> .
                             <#Sean> <#name> "Sean" ."""))
   print tquery(eep.parse('<#Sean> <#likes> ?x .\n<#Sean> <#name> ?y .'), 
                eep.parse("""<#Sean> <#likes> <#TheSimpsons> .
                             <#Sean> <#likes> <#SemanticWeb> .
                             <#Sean> <#likes> <#Music> .
                             <#Sean> <#name> "Sean" ."""))
   print tquery(eep.parse("""?x <#sonOf> ?y .
                             ?y <#sonOf> ?z ."""), 
                eep.parse("""<#Bob> <#sonOf> <#Fred> .
                             <#Fred> <#sonOf> <#John> .
                             <#John> <#sonOf> <#Wayne> ."""), 1)
   print tquery(eep.parse("""<#Aaron> <#likes> ?x ."""), 
                eep.parse("""<#Aaron> <#eats> <#Fred> ."""), 1)
   print tquery(eep.parse("""<#Sean> <#likes> ?x .
                             <#Sean> <#name> ?y .
                             <#Sean> <#blargh> ?z ."""), 
                eep.parse("""<#Sean> <#likes> <#TheSimpsons> .
                             <#Sean> <#name> "Sean" .
                             <#Sean> <#blargh> "x" .
                             <#Sean> <#likes> <#SemanticWeb> .
                             <#Sean> <#blargh> "y" .
                             <#Sean> <#likes> <#Music> ."""), 1)
   print tquery(eep.parse('?x <#name> ?y .\n?x <#likes> ?z .'), 
                eep.parse("""<#Sean> <#likes> <#TheSimpsons> .
                             <#Sean> <#likes> <#TheSemanticWeb> .
                             <#Aaron> <#name> "Aaron" .
                             <#Aaron> <#likes> <#ThePlex> .
                             <#Sean> <#name> "Sean" ."""), 1)

def test(): 
   print 'An squery:-\n'
   print squery(eep.parse('?x <#y> ?z .')[0], 
                eep.parse('<#a> <#y> <#b> .\n<#p> <#y> <#q> .'))
   print '\nAn rquery:-\n'
   print rquery(eep.parse('<#Sean> <#likes> ?x .')[0], 
                eep.parse("""<#Sean> <#likes> <#TheSimpsons> .
                             <#Sean> <#likes> <#SemanticWeb> .
                             <#Sean> <#name> "Sean" ."""))
   print '\nAn xtquery:-\n'
   print tquery(eep.parse("""?x <#sonOf> ?y .
                             ?y <#sonOf> ?z ."""), 
                eep.parse("""<#Bob> <#sonOf> <#Fred> .
                             <#Fred> <#sonOf> <#John> .
                             <#John> <#sonOf> <#Wayne> ."""), 1)

if __name__=="__main__": 
   test()